//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1  clrDeepSkyBlue
#property indicator_color2  clrPaleVioletRed
#property indicator_color3  clrDeepSkyBlue
#property indicator_color4  clrPaleVioletRed
#property indicator_width3  3
#property indicator_width4  3

//
//
//
//
//

enum enTimeFrames
{
   tf_cu  = 0,              // Current time frame
   tf_m1  = PERIOD_M1,      // 1 minute
   tf_m5  = PERIOD_M5,      // 5 minutes
   tf_m15 = PERIOD_M15,     // 15 minutes
   tf_m30 = PERIOD_M30,     // 30 minutes
   tf_h1  = PERIOD_H1,      // 1 hour
   tf_h4  = PERIOD_H4,      // 4 hours
   tf_d1  = PERIOD_D1,      // Daily
   tf_w1  = PERIOD_W1,      // Weekly
   tf_mb1 = PERIOD_MN1,     // Monthly
   tf_cus = 12345678        // Custom time frame
};

extern enTimeFrames       TimeFrame       = tf_cu;    // Time frame
extern int                TimeFrameCustom = 0;        // Custom time frame to use (if custom time frame used)
extern ENUM_APPLIED_PRICE Price           = 0;        // Price
extern int                SmoothLength    = 5;        // Jurik length
extern double             SmoothPhase     = 0;        // Jurik phase
extern bool               SmoothDouble    = false;    // Jurik Double smooth option  
extern int                AtrLength       = 10;       // Atr Length
extern double             Kv              = 4;        // KV distancefrom price
extern double             Filter          = 0;        // Filter to use for filtering (<=0 - no filtering)
extern double             FilterPeriod    = 0;        // Filter period to use ( when <= 0, same as oma period) 
extern double             MoneyRisk       = 1;        // Money risk
extern int                VisualMode      = 1;        // Visual mode 0 = lines 1 = dots
extern bool               alertsOn        = true;     // Turn alerts on?
extern bool               alertsOnCurrent = true;     // Alerts on current (still opened) bar?
extern bool               alertsMessage   = true;     // Alerts should display alert message?
extern bool               alertsSound     = true;     // Alerts should play alert sound?
extern bool               alertsPushNotif = false;    // Alerts should send alert notification?
extern bool               alertsEmail     = false;    // Alerts should send alert email?
extern bool               Interpolate     = true; 


extern bool   showValues            = false;
extern double Valueloc              = .6;
extern string valueIdentifier       = "volty-v1-val";
extern color  txtUpColor            = LawnGreen; //SkyBlue; //Green;
extern color  txtDownColor          = Crimson; //Magenta; //Crimson; //Red

extern bool   verticalLinesVisible     = false;
extern string LineIdentifier           = "volty-v1-Line";
extern color  verticalLinesUpColor     = LawnGreen; //DeepSkyBlue;
extern color  verticalLinesDownColor   = PaleVioletRed;
extern int    verticalLinesStyle       = STYLE_DOT;
extern int    verticalLinesWidth       = 0;
//
//
//
//
//

double UpLine[];
double DnLine[]; 
double UpArrow[];
double DnArrow[]; 
double smax[];
double smin[];
double trend[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
int deinit() 
{ 

   if (showValues) deleteValues();
 
   if(verticalLinesVisible) deleteLines();
  

 return(0);
}
//
//
//

int init()
{
   IndicatorBuffers(7);
      SetIndexBuffer(0,UpLine);  
      SetIndexBuffer(1,DnLine);  
      SetIndexBuffer(2,UpArrow); 
      SetIndexBuffer(3,DnArrow); 
      SetIndexBuffer(4,smax);
      SetIndexBuffer(5,smin);
      SetIndexBuffer(6,trend);
      
      if(VisualMode==0)
      {
      SetIndexStyle(0,DRAW_LINE);
      SetIndexStyle(1,DRAW_LINE);
      }
      else
      {
      SetIndexStyle(0,DRAW_ARROW);SetIndexArrow(0,159);
      SetIndexStyle(1,DRAW_ARROW);SetIndexArrow(1,159);
      }
      SetIndexStyle(2,DRAW_ARROW);SetIndexArrow(2,108);
      SetIndexStyle(3,DRAW_ARROW);SetIndexArrow(3,108);
      
      //
      //
      // 
      //
      //
      
      SmoothLength      = MathMax(SmoothLength,1);
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame==-99; 
      if (TimeFrameCustom==0) TimeFrameCustom = MathMax(TimeFrameCustom,_Period);
      if (TimeFrame!=tf_cus)
            TimeFrame = MathMax(TimeFrame,_Period);
      else  TimeFrame = (enTimeFrames)TimeFrameCustom;
      
      //
      //
      //
      //
      //
       
      IndicatorShortName(timeFrameToString(TimeFrame)+"  Volty Channel Stop");
      return(0);
}
      
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { UpLine[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame == Period())
   {
     for(i=limit; i>=0; i--)
     { 
        double bprice;
        double sprice;
        int fperiod = SmoothLength; if (FilterPeriod>0) fperiod=FilterPeriod;
         if(Price==2 || Price==3)
	      { 
	         bprice =iDSmooth(iFilter(iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH,i),Filter,fperiod,i,0),SmoothLength,SmoothPhase,SmoothDouble,i, 0); 
	         sprice =iDSmooth(iFilter(iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW,i), Filter,fperiod,i,1),SmoothLength,SmoothPhase,SmoothDouble,i,20); 
	      } 	
	      else  
	      { 
	         bprice =iDSmooth(iFilter(iMA(NULL,0,1,0,MODE_SMA,Price,i),Filter,fperiod,i,0),SmoothLength,SmoothPhase,SmoothDouble,i, 0); 
	         sprice =iDSmooth(iFilter(iMA(NULL,0,1,0,MODE_SMA,Price,i),Filter,fperiod,i,1),SmoothLength,SmoothPhase,SmoothDouble,i,20); 
         }
            smin[i]    = sprice - Kv * iATR(NULL,0,AtrLength,i);  
	         smax[i]    = bprice + Kv * iATR(NULL,0,AtrLength,i); 
            UpLine[i]  = EMPTY_VALUE;
            DnLine[i]  = EMPTY_VALUE;
            UpArrow[i] = EMPTY_VALUE;
            DnArrow[i] = EMPTY_VALUE;
            if (i<(Bars-1))
            {
               trend[i]   = trend[i+1]; 
	            if (bprice > smax[i+1]) trend[i] =  1;
               if (sprice < smin[i+1]) trend[i] = -1;
            
	            if (trend[i] > 0 && smin[i] < smin[i+1]) smin[i] = smin[i+1];
	            if (trend[i] < 0 && smax[i] > smax[i+1]) smax[i] = smax[i+1];
               if (trend[i] == 1)
               {  
                  UpLine[i] = smin[i] - (MoneyRisk - 1) * iATR(NULL,0,AtrLength,i); if (trend[i+1]!= 1) UpArrow[i] = UpLine[i];
               }
               if (trend[i] ==-1)
               {  
                  DnLine[i] = smax[i] + (MoneyRisk - 1) * iATR(NULL,0,AtrLength,i); if (trend[i+1]!=-1) DnArrow[i] = DnLine[i];
               }
            }
      
            manageLines(i);   
            manageValue(i);      
      }
      
      //
      //
      //
      //
      //
      
      if (alertsOn)
      {
        int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
        if (trend[whichBar] != trend[whichBar+1])
        if (trend[whichBar] == 1)
              doAlert("up");
        else  doAlert("down");       
      }   
      return(0);
      }
      
      //
      //
      //
      //
      //
   
      limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
      for (i=limit;i>=0; i--)
      {
         int y = iBarShift(NULL,TimeFrame,Time[i]);
            UpLine[i]  = iCustom(NULL,TimeFrame,indicatorFileName,tf_cu,0,Price,SmoothLength,SmoothPhase,SmoothDouble,AtrLength,Kv,Filter,FilterPeriod,MoneyRisk,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsPushNotif,alertsEmail,0,y);
            DnLine[i]  = iCustom(NULL,TimeFrame,indicatorFileName,tf_cu,0,Price,SmoothLength,SmoothPhase,SmoothDouble,AtrLength,Kv,Filter,FilterPeriod,MoneyRisk,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsPushNotif,alertsEmail,1,y);
            UpArrow[i] = EMPTY_VALUE;
            DnArrow[i] = EMPTY_VALUE;
            if (UpLine[i]!= EMPTY_VALUE && UpLine[i+1]==EMPTY_VALUE) UpArrow[i]=UpLine[i];
            if (DnLine[i]!= EMPTY_VALUE && DnLine[i+1]==EMPTY_VALUE) DnArrow[i]=DnLine[i];
               
            //
            //
            //
            //
            //
                        
            if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;

            //
            //
            //
            //
            //

            int n,k; datetime time = iTime(NULL,TimeFrame,y);
               for(n = 1; i+n<Bars && Time[i+n] >= time; n++) continue;	
               for(k = 1; i+n<Bars && i+k<Bars && k<n; k++)
               {
                  if (UpLine[i]!=EMPTY_VALUE && UpLine[i+n]!=EMPTY_VALUE) UpLine[i+k] = UpLine[i] + (UpLine[i+n]-UpLine[i])*k/n;
                  if (DnLine[i]!=EMPTY_VALUE && DnLine[i+n]!=EMPTY_VALUE) DnLine[i+k] = DnLine[i] + (DnLine[i+n]-DnLine[i])*k/n;
               }
   }
return(0);         
}

//+-------------------------------------------------------------------
void manageValue(int i)
{
   if (showValues)
   {
      double dist = iATR(NULL,0,20,i)/Valueloc;
      string on = valueIdentifier+":"+Time[i];
      ObjectDelete(on);         
                
      if (trend[i] != trend[i+1])
         {
            if (trend[i] == 1)
            {
              ObjectCreate(on, OBJ_TEXT, 0, Time[i], Low[i] - dist);
              ObjectSetText(on, DoubleToStr(Close[i], Digits) + " " 
              + TimeToStr(Time[i], TIME_MINUTES), 10, "Arial", txtUpColor);
            }
            else
            if (trend[i] == -1)
            {
              ObjectCreate(on, OBJ_TEXT, 0, Time[i], High[i] + dist);
              ObjectSetText(on, DoubleToStr(Close[i], Digits) + " " 
              + TimeToStr(Time[i], TIME_MINUTES), 10, "Arial", txtDownColor);
            }
         }
   }
}


void deleteValues()
{
   string lookFor       = valueIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}
void deleteValues(datetime time)
{
   string lookFor = valueIdentifier+":"+time; ObjectDelete(lookFor);
}

//+-------------------------------------------------------------------
//| Rk Added Apr 22, 2014                                                                  
//+-------------------------------------------------------------------

void manageLines(int i)
{
   if (verticalLinesVisible )
   {
         deleteLines(Time[i]);
         if (trend[i]!=trend[i+1])
         {
            if (trend[i+1] == -1 ) drawLines(i,verticalLinesUpColor);
            if (trend[i+1] ==  1 ) drawLines(i,verticalLinesDownColor);
         }
   }
}

 //

void drawLines(int i,color theColor)
{
    string name = LineIdentifier+":"+Time[i];
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_VLINE,0,Time[i],0);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_STYLE,verticalLinesStyle);
         ObjectSet(name,OBJPROP_WIDTH,verticalLinesWidth);
         ObjectSet(name,OBJPROP_BACK,true);
}

//
//
//
//
//
void deleteLines()
{
   string lookFor       = LineIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}
void deleteLines(datetime time)
{
   string lookFor = LineIdentifier+":"+time; ObjectDelete(lookFor);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

double wrk[][40];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double tKv  = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - tKv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - tKv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

#define filterInstances 2
double workFil[][filterInstances*3];

#define _fchange 0
#define _fachang 1
#define _fprice  2

double iFilter(double tprice, double filter, int period, int i, int instanceNo=0)
{
   if (filter<=0) return(tprice);
   if (ArrayRange(workFil,0)!= Bars) ArrayResize(workFil,Bars); i = Bars-i-1; instanceNo*=3;
   
   //
   //
   //
   //
   //
   
   workFil[i][instanceNo+_fprice]  = tprice; if (i<1) return(tprice);
   workFil[i][instanceNo+_fchange] = MathAbs(workFil[i][instanceNo+_fprice]-workFil[i-1][instanceNo+_fprice]);
   workFil[i][instanceNo+_fachang] = workFil[i][instanceNo+_fchange];

   for (int k=1; k<period && (i-k)>=0; k++) workFil[i][instanceNo+_fachang] += workFil[i-k][instanceNo+_fchange];
                                            workFil[i][instanceNo+_fachang] /= period;
    
   double stddev = 0; for (k=0;  k<period && (i-k)>=0; k++) stddev += MathPow(workFil[i-k][instanceNo+_fchange]-workFil[i-k][instanceNo+_fachang],2);
          stddev = MathSqrt(stddev/(double)period); 
   double filtev = filter * stddev;
   if( MathAbs(workFil[i][instanceNo+_fprice]-workFil[i-1][instanceNo+_fprice]) < filtev ) workFil[i][instanceNo+_fprice]=workFil[i-1][instanceNo+_fprice];
        return(workFil[i][instanceNo+_fprice]);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message = StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)+" Volty Channel Stop ",doWhat);
             if (alertsMessage)   Alert(message);
             if (alertsPushNotif) SendNotification(message);
             if (alertsEmail)     SendMail(StringConcatenate(Symbol()," Volty Channel Stop "),message);
             if (alertsSound)     PlaySound("alert2.wav");
      }
}

